unit cache_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Grids, registry;

const
  _registry_shell_folder='Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\';

type
  Tc_inx=(
    _cache_file,
    _cache_size,
    _cache_size_format,
    _cache_datetime,
    _cache_state,
    _cache_path,
    _cache_c
  );

function size_format(l:int64):string;

function refresh(sg:tstringgrid;cache_lb,cache_work_lb:tlistbox;firefox_ok,sort_size:bool):integer;

function target_name_random:string;

function reg_ie_cache_path:String;
function reg_firefox_cache_path:String;

function state(fn:string):string;
procedure init(sg:tstringgrid);
procedure catch(sg:tstringgrid;dir,target:string;var counter:integer);
procedure delete(sg:tstringgrid);

function filename_unique(fn_org:string):string;

function pos_buffer(s:string;buf:array of char;buf_len:integer):integer;
function file_is_movie_stream(fn:string;var typ:string;var check_ok:bool):bool;

implementation

uses main_u;

//formatierung von datei-gssenangaben
//aus 8723656 wird z.B. 8,32 MB
function size_format(l:int64):string;
var
  t:int64;
  txt:string;
  dig:integer;
begin
  //zwei nachkommastellen
  dig:=2;
  if l>(1024*1024*1024) then begin
    t:=(1024*1024*1024);
    txt:='GB';
  end
  else if l>(1024*1024) then begin
    t:=(1024*1024);
    txt:='MB';
  end
  else if l>1024 then begin
    t:=1024;
    txt:='KB';
  end
  else begin
    t:=1;
    txt:='Bytes';

    //keine nachkommastellen bei byte-angabe
    dig:=0;
  end;
  result:=floattostrf(l/t,ffnumber,18,dig)+' '+txt;
end;

//initialisierung der cache-stringgrid-----------------
procedure init(sg:tstringgrid);
var
  c:integer;
begin
  sg.align:=alclient;
  {
  sg.cells[ord(_cache_file),0]:='File';
  sg.cells[ord(_cache_size),0]:='Size';
  sg.cells[ord(_cache_datetime),0]:='Datetime';
  sg.cells[ord(_cache_state),0]:='State';
  }
  sg.colcount:=ord(_cache_c);
  sg.rowcount:=1;
  sg.color:=_color_off;
  for c:=0 to sg.colcount-1 do begin
    sg.cells[c,0]:='';
    sg.colwidths[c]:=40;
  end;

  //pfad-spalte verstecken
  sg.colcount:=ord(_cache_c)-1;
end;

//Status einer Datei im Cache ermitteln-----------------------
//result:
// '**ERROR*' wenn Datei fehlt
// 'READY' wenn Download der Datei fertig ist
// 'BLOCKED' wenn Download der Datei noch nicht fertig ist
function state(fn:string):string;
var
  HF:HFile;
  b:byte;
begin
  fn:=ansilowercase(fn);
  b:=2;
  if fileexists(fn) then begin
    HF:=CreateFile(PChar(fn),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,0,0);
    try
      b:=ord(HF=INVALID_HANDLE_VALUE);
    finally
      CloseHandle(HF);
    end;
  end;

  if      b=2 then result:='*ERROR*'
  else if b=0 then result:='READY'
  else             result:='BLOCKED';
end;

//liefert registry path auf ie-cache zurck-----------------------------
function reg_ie_cache_path:String;
var
  reg:TRegistry;
  s:string;
begin
  result:='';
  reg:=TRegistry.Create;
  try
    reg.RootKey:=HKEY_CURRENT_USER;
    if not reg.OpenKey(_registry_shell_folder,false) then exit;
    s:=reg.ReadString('Cache');
    if copy(s,Length(s)-1,1)<>'\' then s:=s+'\';
    result:=s;
  finally
    reg.Free;
  end;
end;

//liefert registry path auf firefox-cache zurck-----------------------------
function reg_firefox_cache_path:String;
var
  reg:TRegistry;
  s:string;
begin
  result:='';
  reg:=TRegistry.Create;
  try
    reg.RootKey:=HKEY_CURRENT_USER;
    if not reg.OpenKey(_registry_shell_folder,false) then exit;
    s:=reg.ReadString('Local AppData');
    if copy(s,Length(s)-1,1)<>'\' then s:=s+'\';
    s:=s+'mozilla\firefox\profiles\';
    result:=s;
  finally
    reg.Free;
  end;
end;

//In Stringgrid selektierte Cache-Datei(en) lschen------------------------
procedure delete(sg:tstringgrid);
var
  row:integer;
  fn:string;
begin
  if application.MessageBox(
    'Are you shure?',
    'Security Check',
    mb_yesno
  )=id_no then exit;

  screen.cursor:=crhourglass;
  for row:=sg.Selection.Top to sg.Selection.Bottom do begin
    fn:=
      sg.Cells[ord(_cache_path),Row]+
      sg.cells[ord(_cache_file),Row];
    if state(fn)='BLOCKED' then continue;
    deletefile(fn);
  end;
  screen.cursor:=crdefault;
end;

{
//prft, ob eine (Cache-)Datei eine FLV-Datei ist-----------------
//bei Firefox haben Cache-Files keine Extension, mann muss also
//reinschauen. Und auch beim IE ist das sicherer, da so manche
//FLV-Datei eine andere Endung trgt (z.B. ".MP4")
function file_is_flv(fn:string):bool;
const
  _bufsz=5;
var
  buf:array[0.._bufsz]of char;
  fhi:thandle;
  rd:cardinal;
begin
  result:=false;

  //Datei zum lesen ffnen
  fhi:=FileOpen(fn,fmOpenREAD or fmShareDenyNone);

  //nicht geklappt? Dann raus
  if fhi=INVALID_HANDLE_VALUE then exit;

  try
    //Die ersten 5 Magic-Bytes einlesen
    if not ReadFile(fhi,buf,_bufsz,rd,nil) then exit;

    //steht dort "FLV"?
    result:=((buf[0]='F')and(buf[1]='L')and(buf[2]='V'));
  finally
    closehandle(fhi);
  end;
end;

//prft, ob eine (Cache-)Datei eine FLV-Datie ist-----------------
//bei Firefox haben Cache-Files keine Extension, mann muss also
//reinschauen. Und auch beim IE ist das sicherer, da so manche
//FLV-Datei eine andere Endung trgt (z.B. ".MP4")
function file_is_mp4(fn:string):bool;
const
  _bufsz=20;
var
  buf:array[0.._bufsz]of char;
  fhi:thandle;
  rd:cardinal;
begin
  result:=false;

  //Datei zum lesen ffnen
  fhi:=FileOpen(fn,fmOpenREAD or fmShareDenyNone);

  //nicht geklappt? Dann raus
  if fhi=INVALID_HANDLE_VALUE then exit;

  try
    //buffer einlesen
    if not ReadFile(fhi,buf,_bufsz,rd,nil) then exit;

    result:=(pos_buffer('ftyp',buf,rd)>-1);
    if result then result:=(pos_buffer('ftypisom',buf,rd)>-1)or(pos_buffer('mp4',buf,rd)>-1);
  finally
    closehandle(fhi);
  end;
end;
}

function pos_buffer(s:string;buf:array of char;buf_len:integer):integer;
var
  c,cc:integer;
  s_chk:string;
begin
  for c:=0 to buf_len-length(s)-1 do begin
    s_chk:='';for cc:=0 to length(s)-1 do s_chk:=s_chk+buf[c+cc];
    if s=s_chk then begin
      result:=c;
      exit;
    end;
  end;
  result:=-1;
end;

//prft, ob eine (Cache-)Datei eine Movie-Stream-Datei ist-----------------
//bei Firefox haben Cache-Files keine Extension, man muss also
//reinschauen. Und auch beim IE ist das sicherer, da so manche
//FLV-Datei eine andere Endung trgt (z.B. ".fid")
//Erkannt werden die Formate: flv, mp4 und wmv
function file_is_movie_stream(fn:string;var typ:string;var check_ok:bool):bool;
const
  _bufsz=50;
var
  buf:array[0.._bufsz]of char;
  fhi:thandle;
  rd:cardinal;
begin
  typ:='';
  check_ok:=false;
  result:=false;

  //Datei zum lesen ffnen
  fhi:=FileOpen(fn,fmOpenREAD or fmShareDenyNone);

  //nicht geklappt? Dann raus
  if fhi=INVALID_HANDLE_VALUE then exit;

  try
    //buffer einlesen
    if not ReadFile(fhi,buf,_bufsz,rd,nil) then exit;
  finally
    closehandle(fhi);
  end;

  //zu wenig infos fr entscheidung
  if rd<_bufsz then begin
    //status ready? dann minifile, keine weitere prfung ntig
    check_ok:=(state(fn)='READY');
    exit;
  end;

  //prfung okay
  check_ok:=true;

  //flv?
  typ:='flv';
  result:=((buf[0]='F')and(buf[1]='L')and(buf[2]='V'));
  if result then exit;

  //wmv?
  typ:='wmv';
  result:=((buf[0]='0')and(buf[1]='&')and(buf[2]=chr($b2)));
  if result then exit;

  //mp4?
  typ:='mp4';
  result:=(pos_buffer('ftyp',buf,rd)>-1);

  //erweitere prfung auf mp4
  if result then result:=(pos_buffer('ftypisom',buf,rd)>-1)or(pos_buffer('mp4',buf,rd)>-1);
  if result then exit;

  //keiner der obigen stream
  typ:='';
end;


//Cache-Stringgrid mit FLV-Dateien fllen-----------------------------
//je nach Auswahl: IE-Cache oder Fireox-Cache
function refresh(sg:tstringgrid;cache_lb,cache_work_lb:tlistbox;firefox_ok,sort_size:bool):integer;
var
  row:integer;
  sg_sl:tstringlist;
  check_c:integer;

  //FLV-Datei-Eintrag in temporre Listbox vornehmen--------------
  procedure addentry(sr:tsearchrec;dir:string);
  var
    dt:tdatetime;
    s,typ,fn_state:string;
    check_ok:bool;
  begin
    inc(check_c);

    //stream-datei? wenn nicht, ignoriere sie
    if not file_is_movie_stream(dir+sr.Name,typ,check_ok) then begin
      //wenn prfung erfolgreich, markiere datei als geprft
      if check_ok then cache_work_lb.items.add(ansilowercase(dir+sr.Name));

      //downloade mehr, knnte eventl. doch ein stream sein
      exit;
    end;

    {
    //if pos('mp4',sr.name)>0 then beep;

    //Kein FLV-Movie?
    if not file_is_flv(dir+sr.name)then begin

      //Auch kein MP4? Dann raus!
      if not file_is_mp4(dir+sr.name)then exit;

    end;
    }

    //Dateidatum sichern
    dt:=FileDateToDateTime(sr.Time);

    //sortierungs-spalte normieren
    if sort_size then begin
      //Sortierung nach Grsse
      s:=inttostr(sr.size);
      while length(s)<10 do s:='0'+s;
    end
    else begin
      //Sortierung nach Dateidatum
      s:=formatdatetime('yymmdd hh:nn:ss',dt);
    end;

    //datei blockiert?
    fn_state:=state(dir+sr.name);

    //Eintrag aufbauen, Sortierspalte nach vorne
    s:=
      s+'|'+
      sr.Name+'|'+
      inttostr(sr.size)+'|'+
      size_format(sr.size)+'|'+
      formatdatetime('yymmdd hh:nn:ss',dt)+'|'+
      fn_state+'|'+
      dir+'|';

    //und Eintrag in temporre Listbox
    sg_sl.add(s);
  end;

  //Ordner und Unterordner rekursiv nach Dateien scannen---------
  procedure dir_scan(dir:string);
  var
    sr:tsearchrec;
    fn,dir_chk:string;
  begin
    application.processmessages;
    if dir[length(dir)]<>'\' then dir:=dir+'\';

    //ordner rekursiv
    if FindFirst(dir+'*.*',faanyfile,sr)=0 then begin
      repeat
        if (sr.Attr and fadirectory)>0 then begin
          if(sr.Name<>'.')and(sr.name<>'..')then begin
            dir_scan(dir+sr.Name+'\');
          end;
        end;
      until FindNext(sr)<>0;
      FindClose(sr);
    end;

    //ordnernamen normiert
    dir_chk:=ansilowercase(copy(dir,1,length(dir)-1));

    //bin ich in einem korrektem ordner?
    if firefox_ok then begin
      //Firefox-Cache
      //bin ich im richtigen Ordner gelandet?
      if pos('\cache',dir_chk)=0 then exit;
    end
    else begin
      //Internet Explorer-Cache
      //bin ich unterhalb vom conten.ie-ordner?
      if pos('content.ie5',dir_chk)=0 then exit;
      if extractfilename(dir_chk)='content.ie5' then exit;
    end;

    //dateien
    if FindFirst(dir+'*',faanyfile,sr)=0 then begin
      repeat
        application.processmessages;
        if (sr.Attr and fadirectory)<=0 then begin

          //bereits geprft?
          fn:=ansilowercase(dir+sr.name);
          if cache_lb.Items.IndexOf(fn)>-1 then begin
            //ja, dann ignoriere cache-datei
            cache_work_lb.items.add(fn);
          end
          else begin
            //nein, prfe die cache-datei ob stream-movie
            addentry(sr,dir);
          end;

        end;
      until FindNext(sr)<>0;
      FindClose(sr);
    end;
  end;

  //liefer string bis zum nchsten "|" zurck
  //modifiziere s, so dass es den Rest enthlt
  function column_next(var s:string):string;
  var
    c:integer;
  begin
    c:=pos('|',s);
    result:=copy(s,1,c-1);
    s:=copy(s,c+1,length(s));
  end;

var
  s:string;
  c,r:integer;
  dir,fn:string;
  colwidths:array[0..ord(_cache_c)]of integer;
  w:integer;
begin
  screen.cursor:=crhourglass;

  //arbeits-cache leeren
  cache_work_lb.clear;

  //markierten cache-eintrag merken
  fn:=
    sg.cells[ord(_cache_path),sg.Row]+
    sg.cells[ord(_cache_file),sg.Row];

  //Cache-Ordner je nach Browser aus Registry holen
  if firefox_ok then dir:=reg_firefox_cache_path
                else dir:=reg_ie_cache_path;

  //stringgrid verstecken
  sg.Visible:=false;

  //stringgrid leeren
  init(sg);

  //anzahl geprfter dateien
  check_c:=0;

  //temporre sztringliste erzeugen
  sg_sl:=tstringlist.Create;
  try
    //sortierung aktiv
    sg_sl.Sorted:=true;

    //flle stringliste mit Cache-Datei-Namen plus Infos
    dir_scan(dir);

    //bertrage Stringliste in Stringgrid
    //Und zwar rckwrts, damit die neusten Dateien bzw.
    //die Grsssten oben stehen
    row:=0;
    for r:=sg_sl.count-1 downto 0 do begin

      //eintrag aus stringliste holen
      //z.B. 00005000|Test|5000|5,00 kb|090627 16:05|c:\...
      s:=sg_sl[r];

      //ignoriere erste "Spalte" (Text bis Delimiter "|")
      //Diese Splate ist nur fr die korrekte Sortierung
      //ntig gewesen
      column_next(s);

      //filter Dateinamen aus
      sg.cells[ord(_cache_file),row]:=column_next(s);

      //Filter Grsse in Bytes aus
      sg.cells[ord(_cache_size),row]:=column_next(s);

      //Filter Grsse in formatierter Schreibweise
      sg.cells[ord(_cache_size_format),row]:=column_next(s);

      //Filter Datetime
      sg.cells[ord(_cache_datetime),row]:=column_next(s);

      //Filter Cache-Datei-Status
      sg.cells[ord(_cache_state),row]:=column_next(s);

      //filter Cache-Pfad
      sg.cells[ord(_cache_path),row]:=column_next(s);

      //erhhe zeilenanzahl der stringgrid
      inc(row);
    end;

    //zeilenanzahl der stringgrid setzen
    if row<1 then row:=1;
    sg.rowcount:=row;

    //ntige breite der spalten berechnen
    //Canvas-Font muss dazu identisch mit Stringgrid-Font sein
    sg.Canvas.Font:=sg.Font;

    //Breitentabelle lschen
    for c:=0 to sg.colCount-1 do colwidths[c]:=0;

    //jede Zelle der Stringgrid wird betrachtet
    for r:=0 to sg.RowCount-1 do begin
      for c:=0 to sg.colCount-1 do begin

        //Inhalt der Zelle
        s:=sg.cells[c,r];

        //Breite in Pixel berechnen (plus etwas Puffer)
        w:=sg.Canvas.TextWidth(s)+5;

        //Maximum auf 300 Pixel beschrnken
        if w>300 then w:=300;

        //Breiteste Splate merken
        if w>colwidths[c] then colwidths[c]:=w;
      end;
    end;

    //Ermittelte Spalten-Breiten setzen
    for c:=0 to sg.colCount-1 do sg.ColWidths[c]:=colwidths[c];

    //Das zu Beginn selektierte File reselektieren
    //(es kann ja inzwischen Position gewechselt haben)
    row:=0;
    for r:=1 to sg.RowCount-1 do begin
      if
        sg.cells[ord(_cache_path),r]+
        sg.cells[ord(_cache_file),r]
        <>
        fn
      then continue;
      row:=r;
      break;
    end;
    sg.row:=row;
  finally
    //Aufraeumen
    sg.Visible:=true;
    sg_sl.free;

    //geprfte cache-files merken
    cache_lb.clear;
    for r:=0 to cache_work_lb.items.count-1 do begin
      cache_lb.items.add(cache_work_lb.items[r]);
    end;

    result:=check_c;

    screen.cursor:=crdefault;
  end;
end;

//Zuflligen Namen bilden aus 5 Zeichen-------------
function target_name_random:string;
begin
  result:=
    chr(random(ord('z')-ord('a'))+ord('a'))+
    chr(random(ord('z')-ord('a'))+ord('a'))+
    chr(random(ord('z')-ord('a'))+ord('a'))+
    chr(random(ord('z')-ord('a'))+ord('a'))+
    chr(random(ord('z')-ord('a'))+ord('a'));
end;

//Liefert eindeutigen Dateinamen zurck---------------------
function filename_unique(fn_org:string):string;
var
  s,fn,dir,fn_alone,bracket:string;
  bracket_ok,file_ok:bool;
  sr:tsearchrec;
  c:integer;
begin
  //Pfad auf Kovertierungs-Spooler
  dir:=extractfilepath(fn_org);

  //Dateinamen freistellen: c:\test[1].flv -> test[1]
  s:=extractfilename(fn_org);
  s:=changefileext(s,'');

  //eckige Klammern aus Dateinamen filtern: test[1] -> test
  bracket_ok:=false;
  fn_alone:='';
  for c:=1 to length(s) do begin

    //Flag setzen/lschen
    if s[c]='[' then bracket_ok:=true
    else if s[c]=']' then begin
      bracket_ok:=false;
      continue;
    end;

    //innerhalb eckiger Klammern?
    if bracket_ok then continue;

    //nein, also Text merken
    fn_alone:=fn_alone+s[c];
  end;

  //eindeutigen Dateinamen (ohne Extension) suchen
  c:=0;
  bracket:='';
  file_ok:=false;
  repeat
    fn:=dir+fn_alone+bracket;

    //Kann Dateinamen verwendet werden?
    if findfirst(fn+'.*',faanyfile,sr)=0 then begin
      //Nein, Dateinamen existiert bereits im Spooler
      FindClose(sr);
    end
    else if findfirst(fn+_flv_org,faanyfile,sr)=0 then begin
      //Nein, zuknftigen Original-Dateinamen existiert bereits im Spooler
      FindClose(sr);
    end
    else if findfirst(fn+_flv_err,faanyfile,sr)=0 then begin
      //Nein, mglicher Fehler-Dateinamen existiert bereits im Spooler
      FindClose(sr);
    end
    else file_ok:=true;

    if not file_ok then begin
      //gefundener Dateinamen womglich nicht eindeutig
      //Nummer anhngen/erhhen und erneut probieren
      //test -> test[1]
      inc(c);
      bracket:='['+inttostr(c)+']';
    end;
  until file_ok;

  result:=fn+'.flv'+_postfix;
end;

//Ersten Zeitstempel aus einer FLV-Datei auslesen--------------------
function timestamp_get(fn:string):string;
const
  _bufsz=1024;
var
  fhi:thandle;
  c,ts:integer;
  rd:cardinal;
  buf:array[0.._bufsz]of char;
  found_c:integer;
begin
  result:='err';

  //ffne Datei zu lesen
  fhi:=FileOpen(fn,fmOpenREAD or fmShareDenyNone);

  //hat es geklappt?
  if fhi=INVALID_HANDLE_VALUE then exit;

  try
    //Puffer leeren
    for c:=0 to _bufsz-1 do buf[c]:=#0;

    //Puffer mit den ersten 1024 Bytes fuellen
    if not ReadFile(fhi,buf,_bufsz,rd,nil) then exit;

    //Taucht im Puffer der Text "starttime" auf?
    found_c:=pos_buffer('starttime',buf,rd);
    {
    found_c:=0;
    for c:=0 to _bufsz-20 do begin
      if
        (buf[c+0]='s') and
        (buf[c+1]='t') and
        (buf[c+2]='a') and
        (buf[c+3]='r') and
        (buf[c+4]='t') and
        (buf[c+5]='t') and
        (buf[c+6]='i') and
        (buf[c+7]='m') and
        (buf[c+8]='e')
      then begin
        //yep, Position merken und raus
        found_c:=c;
        break;
      end;
    end;
    }

    //Starttime-Text gefunden?
    if found_c>-1 then begin
      //Yep, setze Pufferzaehler direkt dahinter
      c:=found_c+10;
    end
    else begin
      //Nope, setze Pufferzaehler auf fixen Wert
      //(empirisch ermittelt, also unsicher)
      c:=$11;
    end;

    //berechne TimeCode aus nchsten drei Bytes
    ts:=byte(buf[c])*256*256;
    ts:=ts+byte(buf[c+1])*256;
    ts:=ts+byte(buf[c+2]);

    result:=inttostr(ts);

    //fuelle Timecode-String auf 10 Zeichen auf
    //(wegen Sortierbarkeit im Stringstyle)
    while length(result)<10 do result:='0'+result;

  finally
    //Aufraeumen
    closehandle(fhi);
  end;
end;

//Kopiere/Verschiebe alle in Cache-Stringgrid selektierten FLV-Datei aus dem
//Cache-Ordner in den Konvertierungs-Spooler
procedure catch(sg:tstringgrid;dir,target:string;var counter:integer);
var
  ext,fn_from,fn_to,timestamp:string;
  row:integer;
  check_ok:bool;
begin
  screen.cursor:=crhourglass;

  for row:=sg.Selection.Top to sg.Selection.Bottom do begin
    fn_from:=sg.Cells[ord(_cache_path),Row]+sg.cells[ord(_cache_file),Row];

    //zielnamen vorgegeben?
    if target='' then target:=sg.cells[ord(_cache_file),Row];


    //typ des stream bestimmen
    if file_is_movie_stream(fn_from,timestamp,check_ok) then begin
      //flv? dann zeitstempel auslesen
      if timestamp='flv' then timestamp:=timestamp_get(fn_from);
    end;

    {
    //kein zeitstempel bei mp4
    timestamp:='mp4';
    if file_is_flv(fn_from) then begin
      //zeitstempel auslesen
      timestamp:=timestamp_get(fn_from);
    end;
    }
    ext:='.flv';

    //eindeutiger zielnamen: test -> test.flv+
    fn_to:=filename_unique(dir+changefileext(target,'_'+timestamp+ext));

    if state(fn_from)='READY' then begin
      //copyfile(pchar(fn_from),pchar(fn_to),false);
      movefile(pchar(fn_from),pchar(fn_to));
      inc(counter);
    end
    else begin
      copyfile(pchar(fn_from),pchar(fn_to),false);
      inc(counter);
    end;
  end;
  screen.cursor:=crdefault;
end;

end.

